/*

The Net Usage Project
http://netusage.mozdev.org/

Copyright (C) 2006, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item
XPCOM

*/

const nuca_contract_id = "@mozilla.org/network/protocol/about;1?what=netusage";
const nuca_class_id = "{e4ea190c-e739-4cc5-9bd1-8ed85c69c685}";



nsNetUsageAbout.prototype = {



	//
	// nsIAboutModule
	//

	newChannel: function(aURI) {
		// process URI
		var uri = decodeURI(aURI.spec);
		var uri = uri.split(/\?/);
		var querystr = uri[1];
		var s = '';
		
		if (querystr == 'add') {
			// open new chrome channel redir
			var iosvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var chan = iosvc.newChannel("chrome://netusageitem/content/add.xhtml", null, null);
		
		} else {

			// dynamic content
			s += '<html><head><title>About your net usage</title></head><body>';

			s += '<h1>My Net Usage</h1>';


			s += '</body></html>';

			// string stream
			var strm = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
			strm.setData(s, -1);

			// create new channel
			var chan = Components.classes["@mozilla.org/network/input-stream-channel;1"].createInstance(Components.interfaces.nsIInputStreamChannel);
			chan.setURI(aURI);
			chan.contentStream = strm;
			chan.contentType = "text/html";
		}
		
		return chan;
	},


	//
	// nsISupports
	//


	QueryInterface: function (iid) {
		if (
			!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsIAboutModule)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
}



function nsNetUsageAbout() {


}




// MODULE
var module = {
	firstTime: true,

	cid: Components.ID(nuca_class_id),

	contractId: nuca_contract_id,

	registerSelf: function (compMgr, fileSpec, location, type) {
		if (this.firstTime) {
			// defer first time registering, I have no idea why though :/
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(this.cid, "NetUsage About Component", this.contractId, fileSpec, location, type);

	},

	unregisterSelf: function(compMgr, fileSpec, location) {
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.unregisterFactoryLocation(this.cid, fileSpec);
	},	

	canUnload: function(compMgr) {
		return true;
	},

	// getClassObject: returns factory object
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.cid)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		if (!iid.equals(Components.interfaces.nsIFactory)) {
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.factory;
	},

	// factory object
	factory: {
		createInstance: function (outer, iid) {
			if (outer != null)
				throw Components.results.NS_ERROR_NO_AGGREGATION;
			return (new nsNetUsageAbout()).QueryInterface(iid);
		}
	}

};

function NSGetModule(compMgr, fileSpec) {
	return module;
}